#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "../bible2.h"

main() {
  char oneline[1000];
  FILE *infptr;
  int fd1, fd2, size, j, k, n, i;
  long int index1;
  struct chapternode1 newchapter;

  size = sizeof(newchapter);

  for(i = 0;i < VERNUM;i++) {
    n = 0;
    index1 = 0;

    infptr = fopen(version1[i].textfilename,"r");
    if ((fd1 = open(version1[i].indexfilename, O_WRONLY | O_CREAT, 0644)) == -1)
      exit(-1);
    if ((fd2 = open(version1[i].lindexfilename,O_WRONLY | O_CREAT, 0644)) == -1)
      exit(-1);

    newchapter.linenum = 0;
    newchapter.index = 0;
    k = 1;
    j = 0;
    write(fd2, &index1, sizeof(long int));
    while((fgets(oneline, 1000, infptr)) != NULL) {
	  if(strstr(oneline, ":1 ")) {
		  n++;
		  if(n > bible_book[k].chap_num) {
			  k++;
			  j = 0;
		  }
		  if(k <= 2)
		    newchapter.pre_num = 0;
		  else
		    newchapter.pre_num = bible_book[k-2].chap_num; 
		  newchapter.next_num = bible_book[k].chap_num;
		  newchapter.chap_num = j+1;
		  newchapter.total_num = bible_book[k].chap_num-bible_book[k-1].chap_num;

		  if(version1[i].language == 'c') {
		    sprintf(newchapter.number, "%s", chapter_num[j]);
		    strcpy(newchapter.name, bible_book[k-1].name);
		    if(!strcmp(newchapter.name, ""))
		      strcat(newchapter.number, "g");
		    else
		      strcat(newchapter.number, "");
		    strcpy(newchapter.full_name, bible_book[k-1].full_name);
		    strcpy(newchapter.next_name, bible_book[k].full_name);
		    if(k > 1)
		      strcpy(newchapter.pre_name, bible_book[k-2].full_name);
		    else
		      newchapter.pre_name[0] = '\0';
		  } else if (version1[i].language == 'e') {
		    strcpy(newchapter.name, bible_book[k-1].en_name);
		    strcpy(newchapter.full_name, bible_book[k-1].en_fullname);
		    if(k > 1)
		      strcpy(newchapter.pre_name, bible_book[k-2].en_fullname);
		    else
		      newchapter.pre_name[0] = '\0';
		    strcpy(newchapter.next_name, bible_book[k].en_fullname);
		    sprintf(newchapter.number, "chapter %d", j+1);
		  } else if(version1[i].language == 'g') {
		    sprintf(newchapter.number, "%s", gb_chapter_num[j]);
		    if(!strcmp(newchapter.name, "ʫ"))
		      strcat(newchapter.number, "ƪ");
		    else
		      strcat(newchapter.number, "");
		    strcpy(newchapter.name, bible_book[k-1].gb_name);
		    strcpy(newchapter.full_name, bible_book[k-1].gb_fullname);
		    strcpy(newchapter.next_name, bible_book[k].gb_fullname);
		    if(k > 1)
		      strcpy(newchapter.pre_name, bible_book[k-2].gb_fullname);
		    else
		      newchapter.pre_name[0] = '\0';
		  }
		  j++;
		  write(fd1, &newchapter, size);
		  printf("%s %s %s %d %d\n", newchapter.name, newchapter.full_name, newchapter.number, newchapter.index, newchapter.linenum);
	  }
	  newchapter.linenum++;
	  newchapter.index += strlen(oneline);
	  index1 = newchapter.index;
	  write(fd2, &index1, sizeof(long int));
    }
    strcpy(newchapter.full_name, "");
    write(fd1, &newchapter, size); // hs@,̫eP_

    fclose(infptr);
    close(fd1);
    close(fd2);
  }
}

