#include "cgic.h"
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "bible.h"

int parse (char [], char [][20]);
void find1(char [], char[][20], int);

char string1[200], c, oneline[300], name1[100], *temp, newold[10], filename[100];
char buf1[300], *foo, target_s[10][30];
FILE *infptr, *outfptr;
int count1=0, len1, fd1, fd2, fd3, size, begin1, end1, i, len2, j, size2, subint1, p1, target_num = 0;
struct indexnode chapter1, chapter2;

void out_string(char oneline[], char out_s[]) {
  int i, j, num = 0, target_pos[100], target_len[100], temp;
  char *out_ptr, *replace_line, temp_out[200];

  for(i = 0;i < target_num;i++) {
    replace_line = oneline;
    while(((replace_line = strstr(replace_line, target_s[i])) != NULL) && ((replace_line - oneline) % 2 == 0)) {
      target_pos[num] = replace_line - oneline;
      target_len[num++] = i;
      replace_line += strlen(target_s[i]);
    }
  }

  for(i = 0;i < num;i++) {
    j = i;
    while((j > 0) && (target_pos[j] < target_pos[j-1])) {
      temp = target_pos[j];
      target_pos[j] = target_pos[j-1];
      target_pos[j-1] = temp;

      temp = target_len[j];
      target_len[j] = target_len[j-1];
      target_len[j-1] = temp;
      j--;
    }
  }

  out_s[0] = '\0';
  replace_line = oneline;
  for(i = 0;i < num;i++) {
    if(oneline + target_pos[i] - replace_line > 0) {
      strncpy(temp_out, replace_line, oneline + target_pos[i] - replace_line);
      temp_out[oneline+target_pos[i]-replace_line] = '\0';
      strcat(out_s, temp_out);
      replace_line = oneline + target_pos[i];
    }

    sprintf(temp_out, "<font color=\"ff0000\">%s</font>", target_s[target_len[i]]);
    strcat(out_s, temp_out);
    replace_line += strlen(target_s[target_len[i]]);
  }
  strcat(out_s, replace_line);
}

int parse (char string1[], char token_a[][20]) {
char string2[200];
int i, len, j = 0, k;

  len = strlen(string1);
  for(i = 0;i < len;i++)
    if(string1[i] != ' ')
      string2[j++] = string1[i];
  string2[j] = '\0';

  len = strlen(string2);
  j = k = 0;
  for(i = 0;i < len;i++) {
    if((string2[i] == '+') ||(string2[i] == '*') ||(string2[i] == ')')) {
      strncpy(token_a[k], string2+j, i-j);
      token_a[k++][i-j] = '\0';

      strncpy(target_s[target_num], string2+j, i-j);
      target_s[target_num++][i-j] = '\0';

      j = i+1;
      token_a[k][0] =  string2[i];
      token_a[k++][1] = '\0';
    }
    else if(string2[i] == '('){
      token_a[k][0] = string2[i];
      token_a[k++][1] = '\0';
      j = i + 1;
    }
  }
  if(string2[i-1] != ')') {
    strcpy(token_a[k++], string2+j);
    strcpy(target_s[target_num++], string2+j);
  }

  return k;
}

int cgiMain() {
char subname[5];
char token_a[20][20];
int token_num, num = 0;

#if DEBUG
        /* Load a saved CGI scenario if we're debugging */
        cgiReadEnvironment("/home/boutell/public_html/capcgi.dat");
#endif

        cgiFormString("newold", newold, 10);
        cgiFormString("name1", name1, 10);
        cgiFormString("string1", string1, 50);
        cgiHeaderContentType("text/html");

        token_num = parse(string1, token_a);
        fprintf(cgiOut,"<html><head>\n");
        fprintf(cgiOut,"<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=big5\">\n");
        fprintf(cgiOut,"<title>gdߵG</title>\n");
        fprintf(cgiOut,"<body text=\"#000050\" link=\"#00ff00\" alink=\"#ffffff\" vlink=\"#0000ff\" background=\"%s\">\n", BACKGROUND);
        fprintf(cgiOut,"<font size=7 color=\"#ff0000\"><center>gdߵG</center></font>\n");
        fprintf(cgiOut,"<hr><font size=5> <ol>\n");

/*        fprintf(cgiOut,"string1=%s\n", string1);

  fprintf(cgiOut,"</body></html>\n");
  return 0;
*/
  if(!strcmp(newold, "new"))
    find1("nt1", token_a, token_num);
  else if(!strcmp(newold, "old")) 
    find1("ot1", token_a, token_num);
  else {
        fprintf(cgiOut,"<font size=6 color=\"0000ff\"><center>¬</center></font><br>\n");
    find1("ot1", token_a, token_num);
        fprintf(cgiOut,"<hr><font size=6 color=\"0000ff\"><center>s</center></font><br>\n");
    find1("nt1", token_a, token_num);
  }

  fprintf(cgiOut,"</ol></font>\n<hr><font color=\"#0000ff\" size=5>@ %d </font>\n",count1);

  fprintf(cgiOut,"</body></html>\n");

  infptr = fopen("/home/fhl/spring/Bible/search.dat", "a");
  fprintf(infptr,"%s\n", string1);
  fclose(infptr);

  infptr = fopen("/home/fhl/spring/Bible/search4.dat", "r");
  fscanf(infptr,"%d", &num);
  fclose(infptr);
  infptr = fopen("/home/fhl/spring/Bible/search4.dat", "w");
  fprintf(infptr,"%d\n", ++num);
  fclose(infptr);

}

void find1(char subname[], char token_a[][20], int token_num)
{
  char stack[20][20], *temp_ptr, out_s[1000];
  FILE *fptr1;
  struct indexnode chap_a[1100];
  int i, line_num = 0, chap_index = 0, parse_state, debug_i=0;

  sprintf(filename, "/home/fhl/spring/Bible/chapter.%s",subname);

/*  if(name1[0] == '\0'){
    fprintf(cgiOut,"J~<br>\n");
    exit(-1);
  }
*/    
  if ((fd1 = open(filename, O_RDONLY)) == -1)
    exit(-1);

  size = sizeof(struct indexnode);
  
  i = 0;
  while(read(fd1, &chapter1, size) > 0) {
    strcpy(chap_a[i].name, chapter1.name);
    chap_a[i++].index = chapter1.index;
  }

  chap_a[i++].index = 32000;
    
  close(fd1);
  
  sprintf(filename, "/home/fhl/spring/Bible/%s.txt",subname);
  if((fptr1 = fopen(filename, "r")) == NULL) {
    fprintf(cgiOut,"ɮ׶}ҿ~<br>\n");  	
    exit(-1);
  }

  while(fgets(oneline, 300, fptr1) != NULL){
    temp_ptr = strstr(oneline, "@") + 2;

    parse_state = parsing(temp_ptr, token_a, token_num);
    if(parse_state == 1) {
      *(temp_ptr-2) = '\0';
      out_string(temp_ptr, out_s);
      fprintf(cgiOut,"<li><a href=\"read5.cgi?%s_%d#v%d\">%s</a>@ %s<p>\n",subname, chap_index+1, line_num - chap_a[chap_index].index + 1, oneline+4, out_s);  
/*      fprintf(cgiOut,"<li><a href=\"read5.cgi?%s_%d#v%d\">%s</a>@ %s<p>\n",subname, chap_index+1, line_num - chap_a[chap_index].index + 1, oneline+4, temp_ptr);   */
      count1++;
    } else if (parse_state == -1)
      fprintf(cgiOut, "J %s ~<br>\n", string1);

    line_num++;
    if(line_num >= chap_a[chap_index+1].index)
      chap_index++;
  }

  fclose(fptr1);
}

int parsing(char one_string[], char token_a[][20], int token_num) {
  int i, stack_top = 0, row, col, temp_top;
  char stack_a[20][20], *c;

  if(strcmp(token_a[ 0], "+") &&strcmp(token_a[0], "*") && strcmp(token_a[0], "(") && strcmp(token_a[0], ")")) {
    c = strstr(one_string, token_a[0]);
    if((c != NULL) && (c - one_string) %2 == 0)
      strcpy(stack_a[stack_top++], "1");
    else
      strcpy(stack_a[stack_top++], "0");
  } else
    strcpy(stack_a[stack_top++], token_a[0]);

  i = 1;
  while((stack_top > 1) ||(i < token_num)) {
    if(strcmp(token_a[ i], "+") &&strcmp(token_a[i], "*") && strcmp(token_a[i], "(") && strcmp(token_a[i], ")")&&(i < token_num)) {
      c = strstr(one_string, token_a[i]);
      if((c != NULL) && (c - one_string) %2 == 0)
        strcpy(stack_a[stack_top++], "1");
      else
        strcpy(stack_a[stack_top++], "0");
      i++;
      continue;
    }
    else if(i >= token_num) col = 4;
    else if(!strcmp(token_a[i], "+")) col = 0;
    else if(!strcmp(token_a[i], "*")) col = 1;
    else if(!strcmp(token_a[i], "(")) col = 2;
    else if(!strcmp(token_a[i], ")")) col = 3;

    if(!strcmp(stack_a[stack_top-1], "1") || !strcmp(stack_a[stack_top-1], "0")) temp_top = stack_top - 2;
      else temp_top = stack_top - 1;
    if (temp_top < 0) row = 4;
    else if(!strcmp(stack_a[temp_top], "+")) row = 0;
    else if(!strcmp(stack_a[temp_top], "*")) row = 1;
    else if(!strcmp(stack_a[temp_top], "(")) row = 2;
    else if(!strcmp(stack_a[temp_top], ")")) row = 3;

    if(precedence[row][col] > 0) {
      stack_top -= 2;
      if(!strcmp(stack_a[stack_top], "+"))
        if(!strcmp(stack_a[stack_top-1], "1") || !strcmp(stack_a[stack_top+1], "1"))
          strcpy(stack_a[stack_top-1], "1");
        else
          strcpy(stack_a[stack_top-1], "0");

      if(!strcmp(stack_a[stack_top], "*"))
        if(!strcmp(stack_a[stack_top-1], "1") && !strcmp(stack_a[stack_top+1], "1"))
          strcpy(stack_a[stack_top-1], "1");
        else
          strcpy(stack_a[stack_top-1], "0");
    }
    else if(precedence[row][col] == 0) {
      stack_top -= 1;
      strcpy(stack_a[stack_top - 1], stack_a[stack_top]);
      i++;
    }
    else if(precedence[row][col] == -2)
      return -1;
    else if(precedence[row][col] == -1)
      strcpy(stack_a[stack_top++], token_a[i++]);
  }

  if(!strcmp(stack_a[0], "1")) return 1;
  else return 0;
}

