<?xml version="1.0" encoding="Big5" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/">
    <html>
    <head>
        <title>tg\Ū  
	  <xsl:value-of select="/bible/book" />  
	  <xsl:value-of select="/bible/chapter" />
	</title>
    </head>
    <body text="#000050" link="#00aa00" alink="#ffffff" vlink="#0000ff" background="back5.jpg">
    <center><h2>
	  <xsl:value-of select="/bible/book" />
	  <xsl:value-of select="/bible/chapter" />
	</h2></center>
    <xsl:apply-templates/>
    </body>
    </html>
</xsl:template>

<xsl:template match="bible">
  <center>
  <xsl:for-each select="otherchapter">
    <a>
      <xsl:attribute name="href"><xsl:value-of select="@href" />
      </xsl:attribute>
      <xsl:value-of select="." />
    </a>@
  </xsl:for-each>
  </center>
  @ <xsl:value-of select="/bible/chapter/@verses" /> `g@
    <xsl:call-template name="slink1">
        <xsl:with-param name="position" select="/bible/prebook" />
    </xsl:call-template>
    <xsl:call-template name="slink1">
        <xsl:with-param name="position" select="/bible/prechapter" />
    </xsl:call-template>
    <xsl:call-template name="slink1">
        <xsl:with-param name="position" select="/bible/nextchapter" />
    </xsl:call-template>
    <xsl:call-template name="slink1">
        <xsl:with-param name="position" select="/bible/nextbook" />
    </xsl:call-template>
  <hr />
  <ol>
  <xsl:for-each select="verse">
    <li>
      <xsl:for-each select="*">
        <xsl:choose>
	  <xsl:when test="name()='ct'">
	    <xsl:value-of select="." />
	  </xsl:when>
	  <xsl:when test="name()='searched'">
	    <div style="color: red;"><xsl:value-of select="." /></div>
	  </xsl:when>
	  <xsl:when test="name()='sn'">
  	    <a>
    	    <xsl:attribute name="href"><xsl:value-of select="@href" />
    	    </xsl:attribute>
    	    <xsl:value-of select="." />
  	    </a>@
	  </xsl:when>
<!--	  <xsl:otherwise>
	    <xsl:value-of select="." />
	  </xsl:otherwise>
-->        </xsl:choose>
      </xsl:for-each>
    </li>
  </xsl:for-each>
  </ol>
  <hr />
    <xsl:call-template name="slink1">
        <xsl:with-param name="position" select="/bible/prebook" />
    </xsl:call-template>
    <xsl:call-template name="slink1">
        <xsl:with-param name="position" select="/bible/prechapter" />
    </xsl:call-template>
    <xsl:call-template name="slink1">
        <xsl:with-param name="position" select="/bible/nextchapter" />
    </xsl:call-template>
    <xsl:call-template name="slink1">
        <xsl:with-param name="position" select="/bible/nextbook" />
    </xsl:call-template>
  <center>
  <xsl:for-each select="otherchapter">
    <a>
      <xsl:attribute name="href"><xsl:value-of select="@href" />
      </xsl:attribute>
      <xsl:value-of select="." />
    </a>@
  </xsl:for-each>
  </center>
</xsl:template>

<xsl:template name="slink1">
  <xsl:param name="position" />
  <a>
    <xsl:attribute name="href"><xsl:value-of select="$position/@href" />
    </xsl:attribute>
    <xsl:value-of select="$position" />
  </a>@
</xsl:template>
</xsl:stylesheet>

